/* cbc-aes256-encrypt.c

   Copyright (C) 2021 Niels Möller

   This file is part of GNU Nettle.

   GNU Nettle is free software: you can redistribute it and/or
   modify it under the terms of either:

     * the GNU Lesser General Public License as published by the Free
       Software Foundation; either version 3 of the License, or (at your
       option) any later version.

   or

     * the GNU General Public License as published by the Free
       Software Foundation; either version 2 of the License, or (at your
       option) any later version.

   or both in parallel, as here.

   GNU Nettle is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received copies of the GNU General Public License and
   the GNU Lesser General Public License along with this program.  If
   not, see http://www.gnu.org/licenses/.
*/

#if HAVE_CONFIG_H
# include "config.h"
#endif

#include "cbc.h"

/* For fat builds */
#if HAVE_NATIVE_cbc_aes256_encrypt
void
_nettle_cbc_aes256_encrypt_c(const struct aes256_ctx *ctx, uint8_t *iv,
			     size_t length, uint8_t *dst,
			     const uint8_t *src);
# define nettle_cbc_aes256_encrypt _nettle_cbc_aes256_encrypt_c
#endif

void
cbc_aes256_encrypt(const struct aes256_ctx *ctx, uint8_t *iv,
		   size_t length, uint8_t *dst, const uint8_t *src)
{
  cbc_encrypt(ctx, (nettle_cipher_func *) aes256_encrypt,
	      AES_BLOCK_SIZE, iv, length, dst, src);
}
